// hook.cpp : DLL AvP[ṼGg |Cg`܂B
//

//**********************************************
//
// gq.cppCƂăRpC邱
//
//**********************************************

#include "stdafx.h"
//#include <stdlib.h>
//#define _DECL_DLLMAIN   /* enable prototypes for DllMain and _CRT_INIT */
//#include <process.h>

// GNX|[g

// Lϐ
#pragma data_seg("HOOK")
HHOOK hKeyBoardHook = NULL;
HHOOK hMouseHook = NULL;
//HHOOK hShellHook = NULL;

__declspec(dllexport) int hookHitCount = 0;
//__declspec(dllexport) BOOL isFullScreen = FALSE;
LPARAM prePos = 0;
#pragma data_seg()


static int __proc_attached = 0;
static HINSTANCE hInstance;
BOOL (WINAPI *_pRawDllMain)(HANDLE, DWORD, LPVOID);

//************************************************************
// DLL
//************************************************************

#ifdef _DEBUG

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	if( ul_reason_for_call == DLL_PROCESS_ATTACH )
		hInstance = (HINSTANCE)hModule;

    return TRUE;
}

#else // _DEBUG

BOOL WINAPI DllCustomStartup(HANDLE hDllHandle, DWORD dwReason, LPVOID lpreserved)
{
    BOOL retcode = TRUE;

    if ( dwReason == DLL_PROCESS_ATTACH || dwReason == DLL_THREAD_ATTACH )
    {
		if ( _pRawDllMain )
		{
            retcode = (*_pRawDllMain)(hDllHandle, dwReason, lpreserved);

			if ( !retcode )
				return FALSE;
		}

		if ( dwReason == DLL_PROCESS_ATTACH ) 
		{
			hInstance = (HINSTANCE)hDllHandle;
			__proc_attached++;
		}
    }
	else if ( (dwReason == DLL_PROCESS_DETACH) || (dwReason == DLL_THREAD_DETACH) )
    {
		if ( dwReason == DLL_PROCESS_DETACH ) {
			if ( __proc_attached > 0 )
				__proc_attached--;
			else
				retcode = FALSE;
		}

        if ( retcode && _pRawDllMain )
            retcode = (*_pRawDllMain)(hDllHandle, dwReason, lpreserved);
    }

    return retcode;
}

#endif // _DEBUG

//************************************************************
// tbN
//************************************************************

// L[{[htbN
LRESULT CALLBACK KeyboardHookProc(int hookInfo, WPARAM wParam, LPARAM lParam)
{
    if( hookInfo >= 0 )
		hookHitCount++;

	return CallNextHookEx(hKeyBoardHook, hookInfo, wParam, lParam);
}

// }EXtbN
LRESULT CALLBACK MouseHookProc(int hookInfo, WPARAM wParam, LPARAM lParam)
{
	if( hookInfo >= 0 ){
		MSG* pMsg = (MSG*)lParam;

		switch( pMsg->message ){
		case WM_MOUSEMOVE:
			if( prePos == pMsg->lParam )
				break;
			// no break
		case WM_MOUSEWHEEL:
		case WM_LBUTTONDOWN:
		case WM_LBUTTONUP:
		case WM_RBUTTONDOWN:
		case WM_RBUTTONUP:
		case WM_MBUTTONDOWN:
		case WM_MBUTTONUP:
			hookHitCount++;
			prePos = pMsg->lParam;
			break;
		default:
			break;
		}
	}

	return CallNextHookEx(hMouseHook, hookInfo, wParam, lParam);
}
/*
LRESULT CALLBACK ShellHookProc(int hookInfo, WPARAM wParam, LPARAM lParam)
{
	if( hookInfo >= 0 ){
		if( hookInfo == HSHELL_WINDOWACTIVATED ){
			isFullScreen = (BOOL)lParam;
		}
	}

	return CallNextHookEx(hMouseHook, hookInfo, wParam, lParam);
}
*/
//************************************************************
// DLLC^[tFCX
//************************************************************

// O[otbN͂
__declspec(dllexport) BOOL __stdcall UnsetHook()
{
	BOOL ret1, ret2;//, ret3;
_RPT0(_CRT_WARN, "UnsetHook\n");

	ret1 = UnhookWindowsHookEx(hKeyBoardHook);
	ret2 = UnhookWindowsHookEx(hMouseHook);
//	ret3 = UnhookWindowsHookEx(hShellHook);

	return ret1 && ret2;// && ret3;
}

// O[otbNZbg
__declspec(dllexport) BOOL __stdcall SetHook()
{
_RPT0(_CRT_WARN, "SetHook ");
	hKeyBoardHook = SetWindowsHookEx(WH_KEYBOARD, KeyboardHookProc, hInstance, 0);
	hMouseHook = SetWindowsHookEx(WH_GETMESSAGE , MouseHookProc, hInstance, 0);
//	hShellHook = SetWindowsHookEx(WH_SHELL, ShellHookProc, hInstance, 0);

	if( hKeyBoardHook == NULL || hMouseHook == NULL ){//|| hShellHook == NULL ){
_RPT0(_CRT_WARN, "NG\n");
		UnsetHook();
		return FALSE;
	}

_RPT0(_CRT_WARN, "OK\n");
	return TRUE;
}
