#pragma once
#include "etc.h"
#include "ListView.h"
#include "dlg.h"

class COptionDlg :
	public CDlg
{
// o
private:
	bool m_bEnable;
	bool m_bOnlineOnly;
	bool m_bEnableRecoverName;
	int m_nFullScrState;
	CondList *m_pCond;
	CListView m_lv;
	StringList m_enables;

public:
	// RXgN^EfXgN^
	COptionDlg(void);
	~COptionDlg(void);

public:
	void SetOnlineOnly(bool bOO)
	{ m_bOnlineOnly = bOO; }
	bool GetOnlineOnly() const
	{ return m_bOnlineOnly; }

	void SetEnablePlugin(bool bEnable)
	{ m_bEnable = bEnable; }
	bool GetEnablePlugin(void) const
	{ return m_bEnable; }

	void SetFullScrState(int nState)
	{ m_nFullScrState = nState; }
	int GetFullScrState() const
	{ return m_nFullScrState; }

	void SetCond(CondList &cond)
	{ m_pCond = &cond; }

	void SetEnableProtocols(StringList &enables)
	{ m_enables = enables; }
	void GetEnableProtocols(StringList &enables) const
	{ enables = m_enables; }

	void SetEnableRecoverName(bool bRecover)
	{ m_bEnableRecoverName = bRecover; }
	bool GetEnableRecoverName(void)
	{ return m_bEnableRecoverName; }

// Cxgnh
private:
	void OnClickEnable();
	void OnClickAdd();
	void OnClickDelete();
	void OnClickSet();
	void OnListDblClick();
	void OnClickEdit();

// ̑
private:
	void EditSelectedItem();
	void EnableAll(BOOL bEnable);
	void UpdateList();
	void UpdateEnables();

// I[o[Ch
public:
	BOOL DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam);

private:
	BOOL InitDlgCtrl();
	BOOL GetDlgCtrlValue();
};
