#pragma once
#include <string>
#pragma warning( disable: 4702 )
	#include <vector>
#pragma warning( default: 4702 )

#define PLUGIN_NAME		"Idle"
#define IDLE_SHOW_OPTION_DIALOG	NMM_ADDIN "/" PLUGIN_NAME "/ShowOptionDialog"
#define IDLE_GET_IDLE_TIME		NMM_ADDIN "/" PLUGIN_NAME "/GetIdleTime"
#define IDLE_IS_IDLING			NMM_ADDIN "/" PLUGIN_NAME "/IsIdling"
#define IDLE_IS_FULLSCREEN		NMM_ADDIN "/" PLUGIN_NAME "/IsFullScreen"

#define STATUS_STRINGS_NUM	10
#define POS_STRINGS_NUM		4

enum {
	AT_NONE,
	AT_PREFIX,
	AT_POSTFIX,
	AT_ALL,
};

extern const LPCSTR STATUS_STRINGS[STATUS_STRINGS_NUM];
extern const LPCSTR POS_STRINGS[];

struct ConditionInfo
{
	int nIdle;
	int nState;
	int nPos;
	std::wstring str;
};

typedef std::vector<ConditionInfo*> CondList;
typedef std::vector<std::string> StringList;
